"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AdditionalFindingsVariantGroupLevelQuestions(ProtocolElement):
    """
    The additional findings variant group level questions
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "clinicalUtility",
        "familyHistoryCondition",
        "familyHistoryFamily",
        "familyHistoryPatient",
        "variantGroup",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "shortTandemRepeatLevelQuestions": reports_6_9_0.ShortTandemRepeatLevelQuestions,
            "structuralVariantLevelQuestions": reports_6_9_0.StructuralVariantLevelQuestions,
            "variantLevelQuestions": reports_6_9_0.VariantLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "clinicalUtility": reports_6_9_0.ClinicalUtility,
            "familyHistoryCondition": reports_6_9_0.FamilyHistoryCondition,
            "familyHistoryFamily": reports_6_9_0.FamilyHistoryFamily,
            "familyHistoryPatient": reports_6_9_0.FamilyHistoryPatient,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.ClinicalUtility": reports_6_9_0.ClinicalUtility,
            "org.gel.models.report.avro.FamilyHistoryCondition": reports_6_9_0.FamilyHistoryCondition,
            "org.gel.models.report.avro.FamilyHistoryFamily": reports_6_9_0.FamilyHistoryFamily,
            "org.gel.models.report.avro.FamilyHistoryPatient": reports_6_9_0.FamilyHistoryPatient,
            "org.gel.models.report.avro.ShortTandemRepeatLevelQuestions": reports_6_9_0.ShortTandemRepeatLevelQuestions,
            "org.gel.models.report.avro.StructuralVariantLevelQuestions": reports_6_9_0.StructuralVariantLevelQuestions,
            "org.gel.models.report.avro.VariantLevelQuestions": reports_6_9_0.VariantLevelQuestions,
            "org.gel.models.report.avro.AdditionalFindingsVariantGroupLevelQuestions": reports_6_9_0.AdditionalFindingsVariantGroupLevelQuestions,
        }

    __slots__ = [
        "clinicalUtility",
        "familyHistoryCondition",
        "familyHistoryFamily",
        "familyHistoryPatient",
        "variantGroup",
        "shortTandemRepeatLevelQuestions",
        "structuralVariantLevelQuestions",
        "variantLevelQuestions",
    ]

    def __init__(
        self,
        clinicalUtility,
        familyHistoryCondition,
        familyHistoryFamily,
        familyHistoryPatient,
        variantGroup,
        shortTandemRepeatLevelQuestions=None,
        structuralVariantLevelQuestions=None,
        variantLevelQuestions=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.AdditionalFindingsVariantGroupLevelQuestions model.

        :param clinicalUtility:
            Has the clinical team identified any changes to clinical care which
            could potentially arise as a result of this
            variant/variant pair?
        :type clinicalUtility: list[ClinicalUtility]
        :param familyHistoryCondition:
            Does this patient have a positive family history relevant to this
            condition?
        :type familyHistoryCondition: FamilyHistoryCondition
        :param familyHistoryFamily:
            In family:
        :type familyHistoryFamily: FamilyHistoryFamily
        :param familyHistoryPatient:
            In patient:
        :type familyHistoryPatient: FamilyHistoryPatient
        :param variantGroup:
            This value groups variants that together could explain the phenotype
            according to the mode of inheritance used. (e.g.: compound
            heterozygous). All the variants in the same report sharing
            the same value will be considered in the same group (i.e.:
            reported together). This value is an integer unique in the
            whole report. These values are only relevant within the
            same report.
        :type variantGroup: int
        :param shortTandemRepeatLevelQuestions:
            STR level questions for each of the variants in the group
        :type shortTandemRepeatLevelQuestions: None | list[ShortTandemRepeatLevelQuestions]
        :param structuralVariantLevelQuestions:
            Structural level questions for each of the variants in the group
        :type structuralVariantLevelQuestions: None | list[StructuralVariantLevelQuestions]
        :param variantLevelQuestions:
            Variant level questions for each of the variants in the group
        :type variantLevelQuestions: None | list[VariantLevelQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
